# How-To Guides

- [Install Substreams CLI](https://docs.substreams.dev/how-to-guides/installing-the-cli.md): StreamingFast Substreams CLI installation documentation
- [Substreams CLI Authentication](https://docs.substreams.dev/how-to-guides/installing-the-cli/authentication.md)
- [Developing Substreams](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams.md)
- [General](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general.md)
- [Agent Skills](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/agent-skills.md)
- [Local Development](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/local-development.md)
- [Troubleshooting](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/local-development/troubleshooting.md)
- [Using Rust & Protobuf](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/using-rust-proto.md)
- [Rust](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/rust.md)
- [Option struct](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/rust/option.md)
- [Result struct](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/rust/result.md)
- [Protobuf](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/general/creating-protobuf-schemas.md): StreamingFast Substreams protobuf schemas
- [on EVM](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm.md)
- [Exploring Ethereum](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm/exploring-ethereum.md)
- [Filter Transactions](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm/exploring-ethereum/map_filter_transactions_module.md)
- [Retrieve Events of a Smart Contract](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm/exploring-ethereum/map_contract_events_module.md)
- [Making eth\_calls](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm/eth-calls.md): Learn how to perform Contract Calls (eth\_calls) in EVM-compatible Substreams
- [Local Development](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm/local-development.md)
- [HardHat](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm/local-development/hardhat.md)
- [Foundry](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-evm/local-development/foundry.md)
- [on Solana](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana.md)
- [Explore Solana](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/explore-solana.md)
- [Filter Instructions](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/explore-solana/filter-instructions.md)
- [Filter Transactions](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/explore-solana/filter-transactions.md)
- [SPL Token Tracker](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/explore-solana/token-tracker.md)
- [NFT Trades](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/explore-solana/nft-trades.md)
- [DEX Trades](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/explore-solana/dex-trades.md)
- [Local Development](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/local-development.md)
- [Anchor](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/local-development/anchor.md)
- [From Yellowstone to Substreams](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/solana/migrate-from-yellowstone.md)
- [on Cosmos](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-cosmos.md)
- [Injective](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-cosmos/injective.md)
- [Simple Substreams Example](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-cosmos/injective/block-stats.md)
- [Foundational Modules](https://docs.substreams.dev/how-to-guides/develop-your-own-substreams/on-cosmos/injective/foundational.md)
- [Composing Substreams](https://docs.substreams.dev/how-to-guides/composing-substreams.md)
- [Foundational Modules](https://docs.substreams.dev/how-to-guides/composing-substreams/foundational-modules.md)
- [Foundational Stores](https://docs.substreams.dev/how-to-guides/composing-substreams/foundational-stores.md): Chain-specific foundational stores
- [Ethereum - ERC20 Token Metadata](https://docs.substreams.dev/how-to-guides/composing-substreams/foundational-stores/erc20-token-metadata.md): ERC20 Token Metadata Foundational Store
- [Solana - SPL Initialized Account](https://docs.substreams.dev/how-to-guides/composing-substreams/foundational-stores/spl-initialized-account.md): SPL Initialized Account Foundational Store
- [Published Packages](https://docs.substreams.dev/how-to-guides/composing-substreams/published-packages.md)
- [Consuming Substreams](https://docs.substreams.dev/how-to-guides/sinks.md)
- [Substreams:SQL](https://docs.substreams.dev/how-to-guides/sinks/sql.md)
- [Using Relational Mappings](https://docs.substreams.dev/how-to-guides/sinks/sql/relational-mappings.md)
- [Using Database Changes](https://docs.substreams.dev/how-to-guides/sinks/sql/db_out.md)
- [Substreams:Stream](https://docs.substreams.dev/how-to-guides/sinks/stream.md)
- [JavaScript](https://docs.substreams.dev/how-to-guides/sinks/stream/javascript.md)
- [Go](https://docs.substreams.dev/how-to-guides/sinks/stream/go.md)
- [Substreams:PubSub](https://docs.substreams.dev/how-to-guides/sinks/pubsub.md)
- [ProtoJSON](https://docs.substreams.dev/how-to-guides/sinks/protojson.md)
- [Files](https://docs.substreams.dev/how-to-guides/sinks/files.md)
- [\[Community Sinks\]](https://docs.substreams.dev/how-to-guides/sinks/community-sinks.md)
- [MongoDB](https://docs.substreams.dev/how-to-guides/sinks/community-sinks/mongodb.md)
- [Key-Value Store](https://docs.substreams.dev/how-to-guides/sinks/community-sinks/kv.md)
- [Prometheus](https://docs.substreams.dev/how-to-guides/sinks/community-sinks/prometheus.md)
- [Publishing a Substreams Package](https://docs.substreams.dev/how-to-guides/publish-package.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.substreams.dev/how-to-guides.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
